// $Id: collapsiblock.js,v 1.8 2007/01/06 07:14:23 nedjo Exp $

Drupal.collapsiblockAutoAttach = function () {
  // Different themes may use different tags for the block title. If there are others used, add them to this array.
  var headTags = ['h2','h3'];
  $('div.block').each(function () {
    var titleElt = null;
    // Ensure we have a collapsable content block element.
    for (var i in headTags) {
      var head = $(this).find(headTags[i]);
      if (head) {
        titleElt = head[0];
        break;
      }
    }
    if (titleElt) {
      // Status values: 1 = not collapsible, 2 = collapsible and expanded, 3 = collapsible and collapsed
      var status = Drupal.settings.collapsiblock[this.id] ? Drupal.settings.collapsiblock[this.id] : 2;
      if (status == 1) {
        return;
      }
      titleElt.target = $(this).find('div.content');

      $(titleElt)
        .addClass('collapsiblock')
        .click(function () {
          $(this).toggleClass('collapsiblockCollapsed');
          $(this.target).slideToggle('slow');
        });
      if (status == 3) {
        $(titleElt).addClass('collapsiblockCollapsed');
        $(titleElt.target).slideUp('fast');
      }
    }
  });
}

// Global Killswitch
if (Drupal.jsEnabled) {
  $(document).ready(Drupal.collapsiblockAutoAttach);
}
