// $Id: dynamicload.js,v 1.9 2007/01/07 22:58:35 nedjo Exp $

Drupal.dynamicloadAutoAttach = function () {
  for (var selector in Drupal.settings.dynamicload) {
    // Only proceed if both source and target elements exist.
    if ($(selector) && $(Drupal.settings.dynamicload[selector])) {
      $(selector + ' a').each(function () {
        Drupal.dynamicload(this, {'target': $(Drupal.settings.dynamicload[selector]).get(0)});
      });
    }
  }
  $('.dynamicload a, a.dynamicload').each(function () {
    Drupal.dynamicload(this);
  });
}

Drupal.dynamicload = function (elt, settings) {
  var target = settings.target ? settings.target : elt;
  // The second argument is to get around an IE bug of returning absolute URLs.
  var href = elt.getAttribute('href', 2);
  // Only process internal site links.
  if (href.indexOf(Drupal.settings.jstools.basePath) == -1) {
    return;
  }
  // Get just the part of the path used by menus.
  href = Drupal.getPath(href);
  $(elt).click(function () {
    var cachedContent = $(target).html();
    // Insert progressbar.
    var progress = new Drupal.progressBar('dynamicloadprogress');
    progress.setProgress(-1, 'Fetching page');
    var progressElt = progress.element;
    $(progressElt).css({
      width: '250px',
      height: '15px',
      paddingTop: '10px'
    });

    $(target)
       .html('')
       .append(progressElt);
    $.ajax({
      type: 'POST',
      data: 'href=' + href + '&target=' + (target.id ? target.id : '0'),
      url: Drupal.url('dynamicload/js'),
      success: function(response){
        $(progressElt).remove();
        progress = null;
        response = Drupal.parseJson(response);
        if (response.result) {
          $(target)
            .html(response.content);
        }
        else {
          var message = response.message ? response.message : 'Unable to load page.';
          alert(message);
          $(target)
            .html(cachedContent);
        }
      }
    });
    return false;
  });
}

// Global Killswitch
if (Drupal.jsEnabled) {
  $(document).ready(Drupal.dynamicloadAutoAttach);
}